using System;
using System.Text;
using System.IO;
class ExpandTabs {
  ///<summary>
  /// ExpandTabs program        Horspool and Bishop     Dec 2002
  /// =================
  /// Replaces tab characters with equivalent numbers of spaces
  /// Illustrates file and string handling
  ///</summary>
  const int inputTabSize = 8;

  string expandTabs(string s) {
    StringBuilder result = new StringBuilder(s.Length+20);
    int col = 0;
    foreach (char c in s) {
      if (c == '\t') {
        do {
          result.Append(' ');
          col++;
        } while(col%inputTabSize != 0);
      } else {
        result.Append(c);
        col++;
      }
    }
    return result.ToString();
  }

  void ProcessFile(string inFileName, string outFileName) {
    StreamReader inStream = new StreamReader(inFileName);
    StreamWriter outStream = new StreamWriter(outFileName);
    for ( ; ; ) {
      string s = inStream.ReadLine();
      if (s == null) break;
      outStream.WriteLine(expandTabs(s.TrimEnd()));
    }
    outStream.Close();
    inStream.Close();
  }

  void Go() {
    Console.Write("Enter the file name: ");
    string inFileName = Console.ReadLine();
    inFileName = inFileName.TrimEnd();
    try {
      StreamReader inStream = new StreamReader(inFileName);
    } catch(Exception e) {
      Console.WriteLine("Unable to open {0}\n{1}",
            inFileName, e.ToString());
      return;
    }
    string outFileName = "CopyOf"+inFileName;
    ProcessFile(inFileName,outFileName);
  }

  static void Main() {
    new ExpandTabs().Go();
  }
}
